<template>
    <!--<div v-bind:style="{backgroundImage : 'url('+image_url+')'}" class="card">-->
    <div v-bind:style="{backgroundImage : 'url('+image_url+')'}" class="card">
        <div class="title-wrapper">
            <div class="rotate-wrapper">
                <div v-if="nowPlaying" v-bind:class="rotating ? 'rotate' : ''" class="now-playing">Now PLaying:
                    {{nowPlaying}}
                </div>
            </div>

            <div class="title-information-wrapper">
                <p class="title"> ID {{id}}</p>
                <button class="delete-card btn-icon" @click.stop="deleteCard()"><img
                        src="../../assets/icons/add.svg"/><span class="visuallyhidden">Delete</span></button>
            </div>


        </div>
    </div>
</template>

<script>

    export default {
        name: 'Card',
        props: {
            type: String,
            nowPlaying: String,
            id: Number,
            image_url: String,
        },

        data() {
            return {
                rotating: false
            }
        },

        mounted() {
            this.calculateRotation();
        },

        methods: {
            calculateRotation: function () {
                let cardWidth = 0;
                let textWidth = 0;
                if(document.getElementsByClassName('card')[0]) {
                    cardWidth = document.getElementsByClassName('card')[0].clientWidth;
                }
                if(document.getElementsByClassName('now-playing')[0]) {
                    textWidth = document.getElementsByClassName('now-playing')[0].scrollWidth;
                }
                if (cardWidth < textWidth) {
                    this.rotating = true
                }
            },
            deleteCard: function () {
                if (this.type === 'room') {
                    this.$parent.deleteRoom(this.id);
                }
                if (this.type === 'playlist') {
                    this.$parent.$parent.deletePlaylist(this.id);
                }
            }
        }
    }
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
    @import "../../assets/theme";

    .card {
        background-position: center;
        background-repeat: no-repeat;
        background-size: cover;
        position: relative;
        width: 100%;
        /*height: 190px;*/
        color: #fff;
        font-weight: 900;

    }

    .title-wrapper {
        position: absolute;
        height: auto;
        width: 100%;
        bottom: 0;
        overflow: hidden;
        display: flex;
        flex-direction: column;
    }

    .title-information-wrapper {
        background-color: rgba(39, 41, 66, 0.95);
        display: flex;
        justify-content: space-between;
        padding: 8px 8px 6px 5px;
    }

    .now-playing {
        white-space: nowrap;
    }

    .title {
        padding: 5px 20px 5px 10px;
        text-align: left;
        margin: 0;
    }

    .delete {
        position: absolute;
        right: 10px;
        bottom: 5px;
    }

    .rotate-wrapper {
        background-color: rgba(214, 191, 59, 0.8);


    }

    .rotate {
        -moz-animation: example1 8s linear infinite;
        -webkit-animation: example1 8s linear infinite;
        animation: example1 8s linear infinite;
        /*background-color: rgba(214, 191, 59, 0.8);*/

    }

    @keyframes example1 {
        0% {
            -moz-transform: translateX(100%);
            -webkit-transform: translateX(100%);
            transform: translateX(100%);
        }
        100% {
            -moz-transform: translateX(-100%);
            -webkit-transform: translateX(-100%);
            transform: translateX(-100%);
        }
    }

    .room-cards > div > div > div {
        background-image: url("../../assets/images/1_sample_group.png") !important;

        &:nth-of-type(2) .card {
            background-image: url("../../assets/images/2_sample_group.png") !important;
        }
        &:nth-of-type(3) .card {
            background-image: url("../../assets/images/3_sample_group.png") !important;
        }
        &:nth-of-type(4) .card {
            background-image: url("../../assets/images/4_sample_group.png") !important;
        }
        &:nth-of-type(5) .card {
            background-image: url("../../assets/images/5_sample_group.png") !important;
        }
        &:nth-of-type(6) .card {
            background-image: url("../../assets/images/6_sample_group.png") !important;
        }
        &:nth-of-type(7) .card {
            background-image: url("../../assets/images/7_sample_group.png") !important;
        }
    }

    .delete-card {
        transform: rotate(45deg);
        align-self: flex-end;
    }


</style>
